config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.icinga2.new
config etc/bash_completion.d/icinga2.new
config etc/logrotate.d/icinga2.new
config etc/sysconfig/icinga2.new

find etc/icinga2 usr/share/icinga2 -type f -name '*.new' \
  | while read new ; do config $new ; done
( cd etc/icinga2/features-enabled ; rm -rf checker.conf )
( cd etc/icinga2/features-enabled ; ln -sf ../features-available/checker.conf checker.conf )
( cd etc/icinga2/features-enabled ; rm -rf notification.conf )
( cd etc/icinga2/features-enabled ; ln -sf ../features-available/notification.conf notification.conf )
( cd etc/icinga2/features-enabled ; rm -rf mainlog.conf )
( cd etc/icinga2/features-enabled ; ln -sf ../features-available/mainlog.conf mainlog.conf )
